/* PolkitDialog.c generated by valac 0.45.3, the Vala compiler
 * generated from PolkitDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <polkitagent/polkitagent.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>

#define AG_WIDGETS_TYPE_POLKIT_DIALOG (ag_widgets_polkit_dialog_get_type ())
#define AG_WIDGETS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog))
#define AG_WIDGETS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))
#define AG_WIDGETS_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))

typedef struct _AgWidgetsPolkitDialog AgWidgetsPolkitDialog;
typedef struct _AgWidgetsPolkitDialogClass AgWidgetsPolkitDialogClass;
typedef struct _AgWidgetsPolkitDialogPrivate AgWidgetsPolkitDialogPrivate;
enum  {
	AG_WIDGETS_POLKIT_DIALOG_0_PROPERTY,
	AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* ag_widgets_polkit_dialog_properties[AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL,
	AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS
};
static guint ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS] = {0};

struct _AgWidgetsPolkitDialog {
	GtkDialog parent_instance;
	AgWidgetsPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgWidgetsPolkitDialogClass {
	GtkDialogClass parent_class;
};

struct _AgWidgetsPolkitDialogPrivate {
	PolkitAgentSession* pk_session;
	PolkitIdentity* pk_identity;
	GCancellable* cancellable;
	gulong error_signal_id;
	gulong request_signal_id;
	gulong info_signal_id;
	gulong complete_signal_id;
	GList* idents;
	gchar* cookie;
	gboolean canceling;
	GtkRevealer* feedback_revealer;
	GtkLabel* password_label;
	GtkLabel* password_feedback;
	GtkEntry* password_entry;
	GtkComboBox* idents_combo;
};

static gint AgWidgetsPolkitDialog_private_offset;
static gpointer ag_widgets_polkit_dialog_parent_class = NULL;

GType ag_widgets_polkit_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AgWidgetsPolkitDialog, g_object_unref)
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_new (const gchar* message,
                                                     const gchar* icon_name,
                                                     const gchar* _cookie,
                                                     GList* _idents,
                                                     GCancellable* _cancellable);
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_construct (GType object_type,
                                                           const gchar* message,
                                                           const gchar* icon_name,
                                                           const gchar* _cookie,
                                                           GList* _idents,
                                                           GCancellable* _cancellable);
static void ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                               gpointer self);
static void ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void __lambda5_ (AgWidgetsPolkitDialog* self);
static void ___lambda5__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static gboolean ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                                  GdkEventKey* key);
static gboolean _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self);
static void _ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                        gpointer self);
static void ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_real_show (GtkWidget* base);
static void ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                                const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                                 const gchar* text,
                                                                                 gpointer self);
static void ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                       gboolean authorized);
static void _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                       gboolean gained_authorization,
                                                                                       gpointer self);
static void ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                             const gchar* request,
                                             gboolean echo_on);
static void _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                           const gchar* request,
                                                                           gboolean echo_on,
                                                                           gpointer self);
static void ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                               const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                               const gchar* text,
                                                                               gpointer self);
static void ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_finalize (GObject * obj);

static inline gpointer
ag_widgets_polkit_dialog_get_instance_private (AgWidgetsPolkitDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AgWidgetsPolkitDialog_private_offset);
}

static void
_ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                          gpointer self)
{
#line 63 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
#line 172 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 95 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_ident_changed ((AgWidgetsPolkitDialog*) self);
#line 181 "PolkitDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 136 "../src/PolkitDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 189 "PolkitDialog.c"
}

static void
__lambda5_ (AgWidgetsPolkitDialog* self)
{
#line 137 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel (self);
#line 197 "PolkitDialog.c"
}

static void
___lambda5__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 137 "../src/PolkitDialog.vala"
	__lambda5_ ((AgWidgetsPolkitDialog*) self);
#line 206 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 141 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_authenticate ((AgWidgetsPolkitDialog*) self);
#line 215 "PolkitDialog.c"
}

static gboolean
_ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self)
{
	gboolean result;
	result = ag_widgets_polkit_dialog_on_key_release ((AgWidgetsPolkitDialog*) self, event);
#line 152 "../src/PolkitDialog.vala"
	return result;
#line 227 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                   gpointer self)
{
#line 153 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
#line 236 "PolkitDialog.c"
}

AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_construct (GType object_type,
                                    const gchar* message,
                                    const gchar* icon_name,
                                    const gchar* _cookie,
                                    GList* _idents,
                                    GCancellable* _cancellable)
{
	AgWidgetsPolkitDialog * self = NULL;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	GtkLabel* heading = NULL;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* message_label = NULL;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkEntry* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkLabel* _tmp25_;
	GtkComboBox* _tmp26_;
	GtkComboBox* _tmp27_;
	GtkComboBox* _tmp28_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRendererPixbuf* _tmp29_;
	GtkComboBox* _tmp30_;
	GtkCellRenderer* _tmp31_;
	GtkComboBox* _tmp32_;
	GtkCellRenderer* _tmp33_;
	GtkCellRendererText* _tmp34_;
	GtkCellRenderer* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkCellRenderer* _tmp37_;
	GtkComboBox* _tmp38_;
	GtkCellRenderer* _tmp39_;
	GtkComboBox* _tmp40_;
	GtkGrid* credentials_grid = NULL;
	GtkGrid* _tmp41_;
	GtkGrid* _tmp42_;
	GtkGrid* _tmp43_;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	GtkComboBox* _tmp46_;
	GtkGrid* _tmp47_;
	GtkEntry* _tmp48_;
	GtkGrid* _tmp49_;
	GtkRevealer* _tmp50_;
	GtkImage* image = NULL;
	GtkImage* _tmp51_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp52_;
	GtkOverlay* _tmp53_;
	GtkOverlay* _tmp54_;
	GtkImage* _tmp55_;
	gboolean _tmp56_ = FALSE;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp63_;
	GtkOverlay* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkButton* cancel_button = NULL;
	GtkWidget* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* authenticate_button = NULL;
	GtkWidget* _tmp70_;
	GtkButton* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkBox* _tmp73_;
	GtkWidget* action_area = NULL;
	GtkWidget* _tmp74_;
	GtkWidget* _tmp75_;
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cookie != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cancellable != NULL, NULL);
#line 52 "../src/PolkitDialog.vala"
	self = (AgWidgetsPolkitDialog*) g_object_new (object_type, "title", _ ("Authentication Dialog"), "window-position", GTK_WIN_POS_CENTER, "resizable", FALSE, "deletable", FALSE, "skip-taskbar-hint", TRUE, NULL);
#line 60 "../src/PolkitDialog.vala"
	self->priv->idents = _idents;
#line 61 "../src/PolkitDialog.vala"
	_tmp0_ = g_strdup (_cookie);
#line 61 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 61 "../src/PolkitDialog.vala"
	self->priv->cookie = _tmp0_;
#line 62 "../src/PolkitDialog.vala"
	self->priv->cancellable = _cancellable;
#line 63 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->cancellable;
#line 63 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp1_, "cancelled", (GCallback) _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled, self, 0);
#line 65 "../src/PolkitDialog.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 67 "../src/PolkitDialog.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Authentication Required"));
#line 67 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp2_);
#line 67 "../src/PolkitDialog.vala"
	heading = _tmp2_;
#line 68 "../src/PolkitDialog.vala"
	_tmp3_ = heading;
#line 68 "../src/PolkitDialog.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 68 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp4_, "primary");
#line 69 "../src/PolkitDialog.vala"
	_tmp5_ = heading;
#line 69 "../src/PolkitDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 70 "../src/PolkitDialog.vala"
	_tmp6_ = heading;
#line 70 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
#line 72 "../src/PolkitDialog.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (message);
#line 72 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp7_);
#line 72 "../src/PolkitDialog.vala"
	message_label = _tmp7_;
#line 73 "../src/PolkitDialog.vala"
	_tmp8_ = message_label;
#line 73 "../src/PolkitDialog.vala"
	gtk_label_set_max_width_chars (_tmp8_, 60);
#line 74 "../src/PolkitDialog.vala"
	_tmp9_ = message_label;
#line 74 "../src/PolkitDialog.vala"
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
#line 75 "../src/PolkitDialog.vala"
	_tmp10_ = message_label;
#line 75 "../src/PolkitDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 76 "../src/PolkitDialog.vala"
	_tmp11_ = message_label;
#line 76 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp11_, (gfloat) 0);
#line 78 "../src/PolkitDialog.vala"
	_tmp12_ = (GtkEntry*) gtk_entry_new ();
#line 78 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 78 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 78 "../src/PolkitDialog.vala"
	self->priv->password_entry = _tmp12_;
#line 79 "../src/PolkitDialog.vala"
	_tmp13_ = self->priv->password_entry;
#line 79 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 80 "../src/PolkitDialog.vala"
	_tmp14_ = self->priv->password_entry;
#line 80 "../src/PolkitDialog.vala"
	g_object_set (_tmp14_, "primary-icon-name", "dialog-password-symbolic", NULL);
#line 81 "../src/PolkitDialog.vala"
	_tmp15_ = self->priv->password_entry;
#line 81 "../src/PolkitDialog.vala"
	g_object_set (_tmp15_, "primary-icon-tooltip-text", _ ("Password"), NULL);
#line 83 "../src/PolkitDialog.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (NULL);
#line 83 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp16_);
#line 83 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 83 "../src/PolkitDialog.vala"
	self->priv->password_feedback = _tmp16_;
#line 84 "../src/PolkitDialog.vala"
	_tmp17_ = self->priv->password_feedback;
#line 84 "../src/PolkitDialog.vala"
	gtk_label_set_justify (_tmp17_, GTK_JUSTIFY_RIGHT);
#line 85 "../src/PolkitDialog.vala"
	_tmp18_ = self->priv->password_feedback;
#line 85 "../src/PolkitDialog.vala"
	gtk_label_set_max_width_chars (_tmp18_, 40);
#line 86 "../src/PolkitDialog.vala"
	_tmp19_ = self->priv->password_feedback;
#line 86 "../src/PolkitDialog.vala"
	g_object_set (_tmp19_, "wrap", TRUE, NULL);
#line 87 "../src/PolkitDialog.vala"
	_tmp20_ = self->priv->password_feedback;
#line 87 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp20_, (gfloat) 1);
#line 88 "../src/PolkitDialog.vala"
	_tmp21_ = self->priv->password_feedback;
#line 88 "../src/PolkitDialog.vala"
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
#line 88 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp22_, GTK_STYLE_CLASS_ERROR);
#line 90 "../src/PolkitDialog.vala"
	_tmp23_ = (GtkRevealer*) gtk_revealer_new ();
#line 90 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 90 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 90 "../src/PolkitDialog.vala"
	self->priv->feedback_revealer = _tmp23_;
#line 91 "../src/PolkitDialog.vala"
	_tmp24_ = self->priv->feedback_revealer;
#line 91 "../src/PolkitDialog.vala"
	_tmp25_ = self->priv->password_feedback;
#line 91 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 93 "../src/PolkitDialog.vala"
	_tmp26_ = (GtkComboBox*) gtk_combo_box_new ();
#line 93 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp26_);
#line 93 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 93 "../src/PolkitDialog.vala"
	self->priv->idents_combo = _tmp26_;
#line 94 "../src/PolkitDialog.vala"
	_tmp27_ = self->priv->idents_combo;
#line 94 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
#line 95 "../src/PolkitDialog.vala"
	_tmp28_ = self->priv->idents_combo;
#line 95 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp28_, "changed", (GCallback) _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed, self, 0);
#line 97 "../src/PolkitDialog.vala"
	_tmp29_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 97 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp29_);
#line 97 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp29_;
#line 98 "../src/PolkitDialog.vala"
	_tmp30_ = self->priv->idents_combo;
#line 98 "../src/PolkitDialog.vala"
	_tmp31_ = renderer;
#line 98 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp30_, _tmp31_, FALSE);
#line 99 "../src/PolkitDialog.vala"
	_tmp32_ = self->priv->idents_combo;
#line 99 "../src/PolkitDialog.vala"
	_tmp33_ = renderer;
#line 99 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp32_, _tmp33_, "icon-name", 0);
#line 101 "../src/PolkitDialog.vala"
	_tmp34_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 101 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp34_);
#line 101 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 101 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp34_;
#line 102 "../src/PolkitDialog.vala"
	_tmp35_ = renderer;
#line 102 "../src/PolkitDialog.vala"
	g_object_set (_tmp35_, "xpad", (guint) 6, NULL);
#line 103 "../src/PolkitDialog.vala"
	_tmp36_ = self->priv->idents_combo;
#line 103 "../src/PolkitDialog.vala"
	_tmp37_ = renderer;
#line 103 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp36_, _tmp37_, TRUE);
#line 104 "../src/PolkitDialog.vala"
	_tmp38_ = self->priv->idents_combo;
#line 104 "../src/PolkitDialog.vala"
	_tmp39_ = renderer;
#line 104 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp38_, _tmp39_, "text", 1);
#line 105 "../src/PolkitDialog.vala"
	_tmp40_ = self->priv->idents_combo;
#line 105 "../src/PolkitDialog.vala"
	gtk_combo_box_set_id_column (_tmp40_, 1);
#line 107 "../src/PolkitDialog.vala"
	_tmp41_ = (GtkGrid*) gtk_grid_new ();
#line 107 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp41_);
#line 107 "../src/PolkitDialog.vala"
	credentials_grid = _tmp41_;
#line 108 "../src/PolkitDialog.vala"
	_tmp42_ = credentials_grid;
#line 108 "../src/PolkitDialog.vala"
	gtk_grid_set_column_spacing (_tmp42_, 12);
#line 109 "../src/PolkitDialog.vala"
	_tmp43_ = credentials_grid;
#line 109 "../src/PolkitDialog.vala"
	gtk_grid_set_row_spacing (_tmp43_, 6);
#line 110 "../src/PolkitDialog.vala"
	_tmp44_ = credentials_grid;
#line 110 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp44_, 12);
#line 111 "../src/PolkitDialog.vala"
	_tmp45_ = credentials_grid;
#line 111 "../src/PolkitDialog.vala"
	_tmp46_ = self->priv->idents_combo;
#line 111 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, 0, 0, 1, 1);
#line 112 "../src/PolkitDialog.vala"
	_tmp47_ = credentials_grid;
#line 112 "../src/PolkitDialog.vala"
	_tmp48_ = self->priv->password_entry;
#line 112 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, 0, 2, 1, 1);
#line 113 "../src/PolkitDialog.vala"
	_tmp49_ = credentials_grid;
#line 113 "../src/PolkitDialog.vala"
	_tmp50_ = self->priv->feedback_revealer;
#line 113 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 0, 3, 1, 1);
#line 115 "../src/PolkitDialog.vala"
	_tmp51_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-password", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 115 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp51_);
#line 115 "../src/PolkitDialog.vala"
	image = _tmp51_;
#line 117 "../src/PolkitDialog.vala"
	_tmp52_ = (GtkOverlay*) gtk_overlay_new ();
#line 117 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp52_);
#line 117 "../src/PolkitDialog.vala"
	overlay = _tmp52_;
#line 118 "../src/PolkitDialog.vala"
	_tmp53_ = overlay;
#line 118 "../src/PolkitDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp53_, GTK_ALIGN_START);
#line 119 "../src/PolkitDialog.vala"
	_tmp54_ = overlay;
#line 119 "../src/PolkitDialog.vala"
	_tmp55_ = image;
#line 119 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp54_, (GtkWidget*) _tmp55_);
#line 121 "../src/PolkitDialog.vala"
	if (g_strcmp0 (icon_name, "") != 0) {
#line 582 "PolkitDialog.c"
		GtkIconTheme* _tmp57_;
#line 121 "../src/PolkitDialog.vala"
		_tmp57_ = gtk_icon_theme_get_default ();
#line 121 "../src/PolkitDialog.vala"
		_tmp56_ = gtk_icon_theme_has_icon (_tmp57_, icon_name);
#line 588 "PolkitDialog.c"
	} else {
#line 121 "../src/PolkitDialog.vala"
		_tmp56_ = FALSE;
#line 592 "PolkitDialog.c"
	}
#line 121 "../src/PolkitDialog.vala"
	if (_tmp56_) {
#line 596 "PolkitDialog.c"
		GtkImage* overlay_image = NULL;
		GtkImage* _tmp58_;
		GtkImage* _tmp59_;
		GtkImage* _tmp60_;
		GtkOverlay* _tmp61_;
		GtkImage* _tmp62_;
#line 122 "../src/PolkitDialog.vala"
		_tmp58_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 122 "../src/PolkitDialog.vala"
		g_object_ref_sink (_tmp58_);
#line 122 "../src/PolkitDialog.vala"
		overlay_image = _tmp58_;
#line 123 "../src/PolkitDialog.vala"
		_tmp59_ = overlay_image;
#line 123 "../src/PolkitDialog.vala"
		_tmp60_ = overlay_image;
#line 123 "../src/PolkitDialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp60_, GTK_ALIGN_END);
#line 123 "../src/PolkitDialog.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp59_, GTK_ALIGN_END);
#line 124 "../src/PolkitDialog.vala"
		_tmp61_ = overlay;
#line 124 "../src/PolkitDialog.vala"
		_tmp62_ = overlay_image;
#line 124 "../src/PolkitDialog.vala"
		gtk_overlay_add_overlay (_tmp61_, (GtkWidget*) _tmp62_);
#line 121 "../src/PolkitDialog.vala"
		_g_object_unref0 (overlay_image);
#line 625 "PolkitDialog.c"
	}
#line 127 "../src/PolkitDialog.vala"
	_tmp63_ = (GtkGrid*) gtk_grid_new ();
#line 127 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp63_);
#line 127 "../src/PolkitDialog.vala"
	grid = _tmp63_;
#line 128 "../src/PolkitDialog.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 129 "../src/PolkitDialog.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 130 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_right ((GtkWidget*) grid, 12);
#line 130 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_left ((GtkWidget*) grid, 12);
#line 131 "../src/PolkitDialog.vala"
	_tmp64_ = overlay;
#line 131 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp64_, 0, 0, 1, 2);
#line 132 "../src/PolkitDialog.vala"
	_tmp65_ = heading;
#line 132 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp65_, 1, 0, 1, 1);
#line 133 "../src/PolkitDialog.vala"
	_tmp66_ = message_label;
#line 133 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp66_, 1, 1, 1, 1);
#line 134 "../src/PolkitDialog.vala"
	_tmp67_ = credentials_grid;
#line 134 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp67_, 1, 2, 1, 1);
#line 136 "../src/PolkitDialog.vala"
	_tmp68_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 136 "../src/PolkitDialog.vala"
	_tmp69_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, gtk_button_get_type (), GtkButton));
#line 136 "../src/PolkitDialog.vala"
	cancel_button = _tmp69_;
#line 137 "../src/PolkitDialog.vala"
	g_signal_connect_object (cancel_button, "clicked", (GCallback) ___lambda5__gtk_button_clicked, self, 0);
#line 139 "../src/PolkitDialog.vala"
	_tmp70_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Authenticate"), (gint) GTK_RESPONSE_APPLY);
#line 139 "../src/PolkitDialog.vala"
	_tmp71_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, gtk_button_get_type (), GtkButton));
#line 139 "../src/PolkitDialog.vala"
	authenticate_button = _tmp71_;
#line 140 "../src/PolkitDialog.vala"
	_tmp72_ = gtk_widget_get_style_context ((GtkWidget*) authenticate_button);
#line 140 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp72_, "suggested-action");
#line 141 "../src/PolkitDialog.vala"
	g_signal_connect_object (authenticate_button, "clicked", (GCallback) _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked, self, 0);
#line 143 "../src/PolkitDialog.vala"
	gtk_window_set_default ((GtkWindow*) self, (GtkWidget*) authenticate_button);
#line 145 "../src/PolkitDialog.vala"
	_tmp73_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 145 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp73_, (GtkWidget*) grid);
#line 147 "../src/PolkitDialog.vala"
	_tmp74_ = gtk_dialog_get_action_area ((GtkDialog*) self);
#line 147 "../src/PolkitDialog.vala"
	_tmp75_ = _g_object_ref0 (_tmp74_);
#line 147 "../src/PolkitDialog.vala"
	action_area = _tmp75_;
#line 148 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_right (action_area, 6);
#line 149 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_bottom (action_area, 6);
#line 150 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_top (action_area, 14);
#line 152 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event, self, 0);
#line 153 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "close", (GCallback) _ag_widgets_polkit_dialog_cancel_gtk_dialog_close, self, 0);
#line 155 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_update_idents (self);
#line 156 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_select_session (self);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (action_area);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (authenticate_button);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (cancel_button);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (grid);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (overlay);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (image);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (credentials_grid);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (message_label);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (heading);
#line 50 "../src/PolkitDialog.vala"
	return self;
#line 725 "PolkitDialog.c"
}

AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_new (const gchar* message,
                              const gchar* icon_name,
                              const gchar* _cookie,
                              GList* _idents,
                              GCancellable* _cancellable)
{
#line 50 "../src/PolkitDialog.vala"
	return ag_widgets_polkit_dialog_construct (AG_WIDGETS_TYPE_POLKIT_DIALOG, message, icon_name, _cookie, _idents, _cancellable);
#line 737 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_real_show (GtkWidget* base)
{
	AgWidgetsPolkitDialog * self;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkEntry* _tmp4_;
#line 159 "../src/PolkitDialog.vala"
	self = (AgWidgetsPolkitDialog*) base;
#line 160 "../src/PolkitDialog.vala"
	GTK_WIDGET_CLASS (ag_widgets_polkit_dialog_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_dialog_get_type (), GtkDialog));
#line 162 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 162 "../src/PolkitDialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 162 "../src/PolkitDialog.vala"
	window = _tmp1_;
#line 163 "../src/PolkitDialog.vala"
	_tmp2_ = window;
#line 163 "../src/PolkitDialog.vala"
	if (_tmp2_ == NULL) {
#line 164 "../src/PolkitDialog.vala"
		_g_object_unref0 (window);
#line 164 "../src/PolkitDialog.vala"
		return;
#line 768 "PolkitDialog.c"
	}
#line 167 "../src/PolkitDialog.vala"
	_tmp3_ = window;
#line 167 "../src/PolkitDialog.vala"
	gdk_window_focus (_tmp3_, (guint32) GDK_CURRENT_TIME);
#line 168 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 168 "../src/PolkitDialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 159 "../src/PolkitDialog.vala"
	_g_object_unref0 (window);
#line 780 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self)
{
	GtkListStore* model = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint length = 0;
	gint active = 0;
	gchar* target_user = NULL;
	GList* _tmp1_;
	GtkComboBox* _tmp34_;
	GtkListStore* _tmp35_;
	GtkComboBox* _tmp36_;
#line 171 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, polkit_identity_get_type (), -1);
#line 172 "../src/PolkitDialog.vala"
	model = _tmp0_;
#line 175 "../src/PolkitDialog.vala"
	length = 0;
#line 176 "../src/PolkitDialog.vala"
	active = 0;
#line 178 "../src/PolkitDialog.vala"
	target_user = NULL;
#line 180 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->idents;
#line 810 "PolkitDialog.c"
	{
		GList* ident_collection = NULL;
		GList* ident_it = NULL;
#line 180 "../src/PolkitDialog.vala"
		ident_collection = _tmp1_;
#line 180 "../src/PolkitDialog.vala"
		for (ident_it = ident_collection; ident_it != NULL; ident_it = ident_it->next) {
#line 818 "PolkitDialog.c"
			PolkitIdentity* ident = NULL;
#line 180 "../src/PolkitDialog.vala"
			ident = (PolkitIdentity*) ident_it->data;
#line 822 "PolkitDialog.c"
			{
				PolkitIdentity* _tmp2_;
				gchar* name = NULL;
				PolkitIdentity* _tmp3_;
				gchar* _tmp4_;
				PolkitIdentity* _tmp5_;
				GtkListStore* _tmp25_;
				GtkTreeIter _tmp26_ = {0};
				GtkListStore* _tmp27_;
				GtkTreeIter _tmp28_;
				const gchar* _tmp29_;
				PolkitIdentity* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
#line 181 "../src/PolkitDialog.vala"
				_tmp2_ = ident;
#line 181 "../src/PolkitDialog.vala"
				if (_tmp2_ == NULL) {
#line 182 "../src/PolkitDialog.vala"
					continue;
#line 844 "PolkitDialog.c"
				}
#line 185 "../src/PolkitDialog.vala"
				_tmp3_ = ident;
#line 185 "../src/PolkitDialog.vala"
				_tmp4_ = polkit_identity_to_string (_tmp3_);
#line 185 "../src/PolkitDialog.vala"
				name = _tmp4_;
#line 187 "../src/PolkitDialog.vala"
				_tmp5_ = ident;
#line 187 "../src/PolkitDialog.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, polkit_unix_user_get_type ())) {
#line 856 "PolkitDialog.c"
					struct passwd* pwd = NULL;
					PolkitIdentity* _tmp6_;
					struct passwd* _tmp7_;
					struct passwd* _tmp8_;
#line 188 "../src/PolkitDialog.vala"
					_tmp6_ = ident;
#line 188 "../src/PolkitDialog.vala"
					_tmp7_ = getpwuid ((uid_t) polkit_unix_user_get_uid (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, polkit_unix_user_get_type (), PolkitUnixUser)));
#line 188 "../src/PolkitDialog.vala"
					pwd = _tmp7_;
#line 189 "../src/PolkitDialog.vala"
					_tmp8_ = pwd;
#line 189 "../src/PolkitDialog.vala"
					if (_tmp8_ != NULL) {
#line 871 "PolkitDialog.c"
						gchar* pw_name = NULL;
						struct passwd* _tmp9_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						const gchar* _tmp13_;
						const gchar* _tmp16_;
						gchar* _tmp17_;
#line 190 "../src/PolkitDialog.vala"
						_tmp9_ = pwd;
#line 190 "../src/PolkitDialog.vala"
						_tmp10_ = _tmp9_->pw_name;
#line 190 "../src/PolkitDialog.vala"
						_tmp11_ = g_strdup (_tmp10_);
#line 190 "../src/PolkitDialog.vala"
						pw_name = _tmp11_;
#line 191 "../src/PolkitDialog.vala"
						_tmp13_ = target_user;
#line 191 "../src/PolkitDialog.vala"
						if (_tmp13_ == NULL) {
#line 191 "../src/PolkitDialog.vala"
							_tmp12_ = length < 2;
#line 894 "PolkitDialog.c"
						} else {
#line 191 "../src/PolkitDialog.vala"
							_tmp12_ = FALSE;
#line 898 "PolkitDialog.c"
						}
#line 191 "../src/PolkitDialog.vala"
						if (_tmp12_) {
#line 902 "PolkitDialog.c"
							const gchar* _tmp14_;
							gchar* _tmp15_;
#line 192 "../src/PolkitDialog.vala"
							_tmp14_ = pw_name;
#line 192 "../src/PolkitDialog.vala"
							_tmp15_ = g_strdup (_tmp14_);
#line 192 "../src/PolkitDialog.vala"
							_g_free0 (target_user);
#line 192 "../src/PolkitDialog.vala"
							target_user = _tmp15_;
#line 913 "PolkitDialog.c"
						}
#line 195 "../src/PolkitDialog.vala"
						_tmp16_ = pw_name;
#line 195 "../src/PolkitDialog.vala"
						_tmp17_ = g_strdup (_tmp16_);
#line 195 "../src/PolkitDialog.vala"
						_g_free0 (name);
#line 195 "../src/PolkitDialog.vala"
						name = _tmp17_;
#line 189 "../src/PolkitDialog.vala"
						_g_free0 (pw_name);
#line 925 "PolkitDialog.c"
					}
				} else {
					PolkitIdentity* _tmp18_;
#line 197 "../src/PolkitDialog.vala"
					_tmp18_ = ident;
#line 197 "../src/PolkitDialog.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, polkit_unix_group_get_type ())) {
#line 933 "PolkitDialog.c"
						struct group* gwd = NULL;
						PolkitIdentity* _tmp19_;
						struct group* _tmp20_;
						struct group* _tmp21_;
#line 198 "../src/PolkitDialog.vala"
						_tmp19_ = ident;
#line 198 "../src/PolkitDialog.vala"
						_tmp20_ = getgrgid ((gid_t) polkit_unix_group_get_gid (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, polkit_unix_group_get_type (), PolkitUnixGroup)));
#line 198 "../src/PolkitDialog.vala"
						gwd = _tmp20_;
#line 199 "../src/PolkitDialog.vala"
						_tmp21_ = gwd;
#line 199 "../src/PolkitDialog.vala"
						if (_tmp21_ != NULL) {
#line 948 "PolkitDialog.c"
							struct group* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 200 "../src/PolkitDialog.vala"
							_tmp22_ = gwd;
#line 200 "../src/PolkitDialog.vala"
							_tmp23_ = _tmp22_->gr_name;
#line 200 "../src/PolkitDialog.vala"
							_tmp24_ = g_strdup_printf (_ ("Group: %s"), _tmp23_);
#line 200 "../src/PolkitDialog.vala"
							_g_free0 (name);
#line 200 "../src/PolkitDialog.vala"
							name = _tmp24_;
#line 962 "PolkitDialog.c"
						}
					}
				}
#line 204 "../src/PolkitDialog.vala"
				_tmp25_ = model;
#line 204 "../src/PolkitDialog.vala"
				gtk_list_store_append (_tmp25_, &_tmp26_);
#line 204 "../src/PolkitDialog.vala"
				iter = _tmp26_;
#line 205 "../src/PolkitDialog.vala"
				_tmp27_ = model;
#line 205 "../src/PolkitDialog.vala"
				_tmp28_ = iter;
#line 205 "../src/PolkitDialog.vala"
				_tmp29_ = name;
#line 205 "../src/PolkitDialog.vala"
				_tmp30_ = ident;
#line 205 "../src/PolkitDialog.vala"
				gtk_list_store_set (_tmp27_, &_tmp28_, 0, "avatar-default-symbolic", 1, _tmp29_, 2, _tmp30_, -1);
#line 207 "../src/PolkitDialog.vala"
				_tmp31_ = name;
#line 207 "../src/PolkitDialog.vala"
				_tmp32_ = g_get_user_name ();
#line 207 "../src/PolkitDialog.vala"
				if (g_strcmp0 (_tmp31_, _tmp32_) == 0) {
#line 208 "../src/PolkitDialog.vala"
					active = length;
#line 990 "PolkitDialog.c"
				}
#line 211 "../src/PolkitDialog.vala"
				_tmp33_ = length;
#line 211 "../src/PolkitDialog.vala"
				length = _tmp33_ + 1;
#line 180 "../src/PolkitDialog.vala"
				_g_free0 (name);
#line 998 "PolkitDialog.c"
			}
		}
	}
#line 214 "../src/PolkitDialog.vala"
	_tmp34_ = self->priv->idents_combo;
#line 214 "../src/PolkitDialog.vala"
	_tmp35_ = model;
#line 214 "../src/PolkitDialog.vala"
	gtk_combo_box_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
#line 215 "../src/PolkitDialog.vala"
	_tmp36_ = self->priv->idents_combo;
#line 215 "../src/PolkitDialog.vala"
	gtk_combo_box_set_active (_tmp36_, active);
#line 217 "../src/PolkitDialog.vala"
	if (length < 2) {
#line 1014 "PolkitDialog.c"
		const gchar* _tmp37_;
		const gchar* _tmp38_;
#line 218 "../src/PolkitDialog.vala"
		_tmp37_ = target_user;
#line 218 "../src/PolkitDialog.vala"
		_tmp38_ = g_get_user_name ();
#line 218 "../src/PolkitDialog.vala"
		if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 1023 "PolkitDialog.c"
			GtkComboBox* _tmp39_;
			GtkComboBox* _tmp40_;
#line 219 "../src/PolkitDialog.vala"
			_tmp39_ = self->priv->idents_combo;
#line 219 "../src/PolkitDialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
#line 220 "../src/PolkitDialog.vala"
			_tmp40_ = self->priv->idents_combo;
#line 220 "../src/PolkitDialog.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp40_, TRUE);
#line 1034 "PolkitDialog.c"
		} else {
			GtkComboBox* _tmp41_;
#line 222 "../src/PolkitDialog.vala"
			_tmp41_ = self->priv->idents_combo;
#line 222 "../src/PolkitDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp41_, FALSE);
#line 1041 "PolkitDialog.c"
		}
	}
#line 171 "../src/PolkitDialog.vala"
	_g_free0 (target_user);
#line 171 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1048 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                            const gchar* text,
                                                                            gpointer self)
{
#line 233 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_show_error ((AgWidgetsPolkitDialog*) self, text);
#line 1058 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                  gboolean gained_authorization,
                                                                                  gpointer self)
{
#line 234 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_session_completed ((AgWidgetsPolkitDialog*) self, gained_authorization);
#line 1068 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                      const gchar* request,
                                                                      gboolean echo_on,
                                                                      gpointer self)
{
#line 235 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_request ((AgWidgetsPolkitDialog*) self, request, echo_on);
#line 1079 "PolkitDialog.c"
}

static void
_ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                          const gchar* text,
                                                                          gpointer self)
{
#line 236 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_show_info ((AgWidgetsPolkitDialog*) self, text);
#line 1089 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	PolkitIdentity* _tmp1_;
	const gchar* _tmp2_;
	PolkitAgentSession* _tmp3_;
	PolkitAgentSession* _tmp4_;
	gulong _tmp5_;
	PolkitAgentSession* _tmp6_;
	gulong _tmp7_;
	PolkitAgentSession* _tmp8_;
	gulong _tmp9_;
	PolkitAgentSession* _tmp10_;
	gulong _tmp11_;
	PolkitAgentSession* _tmp12_;
#line 227 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 228 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 229 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 1116 "PolkitDialog.c"
	}
#line 232 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->pk_identity;
#line 232 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->cookie;
#line 232 "../src/PolkitDialog.vala"
	_tmp3_ = polkit_agent_session_new (_tmp1_, _tmp2_);
#line 232 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 232 "../src/PolkitDialog.vala"
	self->priv->pk_session = _tmp3_;
#line 233 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->pk_session;
#line 233 "../src/PolkitDialog.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "show-error", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error, self, 0);
#line 233 "../src/PolkitDialog.vala"
	self->priv->error_signal_id = _tmp5_;
#line 234 "../src/PolkitDialog.vala"
	_tmp6_ = self->priv->pk_session;
#line 234 "../src/PolkitDialog.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "completed", (GCallback) _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed, self, 0);
#line 234 "../src/PolkitDialog.vala"
	self->priv->complete_signal_id = _tmp7_;
#line 235 "../src/PolkitDialog.vala"
	_tmp8_ = self->priv->pk_session;
#line 235 "../src/PolkitDialog.vala"
	_tmp9_ = g_signal_connect_object (_tmp8_, "request", (GCallback) _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request, self, 0);
#line 235 "../src/PolkitDialog.vala"
	self->priv->request_signal_id = _tmp9_;
#line 236 "../src/PolkitDialog.vala"
	_tmp10_ = self->priv->pk_session;
#line 236 "../src/PolkitDialog.vala"
	_tmp11_ = g_signal_connect_object (_tmp10_, "show-info", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info, self, 0);
#line 236 "../src/PolkitDialog.vala"
	self->priv->info_signal_id = _tmp11_;
#line 237 "../src/PolkitDialog.vala"
	_tmp12_ = self->priv->pk_session;
#line 237 "../src/PolkitDialog.vala"
	polkit_agent_session_initiate (_tmp12_);
#line 1156 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 240 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 241 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1169 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
		PolkitAgentSession* _tmp2_;
		PolkitAgentSession* _tmp3_;
		PolkitAgentSession* _tmp4_;
#line 242 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 242 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp1_, self->priv->error_signal_id);
#line 243 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->pk_session;
#line 243 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp2_, self->priv->complete_signal_id);
#line 244 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->pk_session;
#line 244 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp3_, self->priv->request_signal_id);
#line 245 "../src/PolkitDialog.vala"
		_tmp4_ = self->priv->pk_session;
#line 245 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp4_, self->priv->info_signal_id);
#line 246 "../src/PolkitDialog.vala"
		_g_object_unref0 (self->priv->pk_session);
#line 246 "../src/PolkitDialog.vala"
		self->priv->pk_session = NULL;
#line 1194 "PolkitDialog.c"
	}
}

static void
ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	GtkEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	PolkitAgentSession* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
#line 250 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 251 "../src/PolkitDialog.vala"
	if (_tmp0_ == NULL) {
#line 252 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_select_session (self);
#line 1215 "PolkitDialog.c"
	}
#line 255 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_entry;
#line 255 "../src/PolkitDialog.vala"
	g_object_set (_tmp1_, "secondary-icon-name", "", NULL);
#line 256 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 256 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 258 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 259 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->pk_session;
#line 259 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 259 "../src/PolkitDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 259 "../src/PolkitDialog.vala"
	polkit_agent_session_response (_tmp3_, _tmp5_);
#line 1235 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 262 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/PolkitDialog.vala"
	self->priv->canceling = TRUE;
#line 264 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 264 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1250 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
#line 265 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 265 "../src/PolkitDialog.vala"
		polkit_agent_session_cancel (_tmp1_);
#line 1256 "PolkitDialog.c"
	}
#line 268 "../src/PolkitDialog.vala"
	g_debug ("PolkitDialog.vala:268: Authentication cancelled");
#line 269 "../src/PolkitDialog.vala"
	self->was_canceled = TRUE;
#line 271 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 272 "../src/PolkitDialog.vala"
	g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1266 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	PolkitIdentity* _tmp9_ = NULL;
#line 275 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->idents_combo;
#line 278 "../src/PolkitDialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 278 "../src/PolkitDialog.vala"
	iter = _tmp1_;
#line 278 "../src/PolkitDialog.vala"
	if (!_tmp2_) {
#line 279 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 280 "../src/PolkitDialog.vala"
		return;
#line 1298 "PolkitDialog.c"
	}
#line 283 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->idents_combo;
#line 283 "../src/PolkitDialog.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 283 "../src/PolkitDialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 283 "../src/PolkitDialog.vala"
	model = _tmp5_;
#line 284 "../src/PolkitDialog.vala"
	_tmp6_ = model;
#line 284 "../src/PolkitDialog.vala"
	if (_tmp6_ == NULL) {
#line 285 "../src/PolkitDialog.vala"
		_g_object_unref0 (model);
#line 285 "../src/PolkitDialog.vala"
		return;
#line 1316 "PolkitDialog.c"
	}
#line 288 "../src/PolkitDialog.vala"
	_tmp7_ = model;
#line 288 "../src/PolkitDialog.vala"
	_tmp8_ = iter;
#line 288 "../src/PolkitDialog.vala"
	gtk_tree_model_get (_tmp7_, &_tmp8_, 2, &_tmp9_, -1, -1);
#line 288 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 288 "../src/PolkitDialog.vala"
	self->priv->pk_identity = _tmp9_;
#line 289 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_select_session (self);
#line 275 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1332 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                  gboolean authorized)
{
	gboolean _tmp0_ = FALSE;
#line 292 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 294 "../src/PolkitDialog.vala"
	if (!authorized) {
#line 294 "../src/PolkitDialog.vala"
		_tmp0_ = TRUE;
#line 1348 "PolkitDialog.c"
	} else {
		GCancellable* _tmp1_;
#line 294 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 294 "../src/PolkitDialog.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp1_);
#line 1355 "PolkitDialog.c"
	}
#line 294 "../src/PolkitDialog.vala"
	if (_tmp0_) {
#line 1359 "PolkitDialog.c"
		GtkEntry* _tmp2_;
		GtkEntry* _tmp3_;
#line 295 "../src/PolkitDialog.vala"
		if (!self->priv->canceling) {
#line 296 "../src/PolkitDialog.vala"
			ag_widgets_polkit_dialog_on_pk_show_error (self, _ ("Authentication failed. Please try again."));
#line 1366 "PolkitDialog.c"
		}
#line 299 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 300 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->password_entry;
#line 300 "../src/PolkitDialog.vala"
		gtk_entry_set_text (_tmp2_, "");
#line 301 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->password_entry;
#line 301 "../src/PolkitDialog.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 302 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_select_session (self);
#line 303 "../src/PolkitDialog.vala"
		return;
#line 1382 "PolkitDialog.c"
	} else {
#line 305 "../src/PolkitDialog.vala"
		g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1386 "PolkitDialog.c"
	}
}

static void
ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                        const gchar* request,
                                        gboolean echo_on)
{
	GtkEntry* _tmp0_;
#line 309 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/PolkitDialog.vala"
	g_return_if_fail (request != NULL);
#line 310 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 310 "../src/PolkitDialog.vala"
	gtk_entry_set_visibility (_tmp0_, echo_on);
#line 311 "../src/PolkitDialog.vala"
	if (!g_str_has_prefix (request, "Password:")) {
#line 1406 "PolkitDialog.c"
		GtkLabel* _tmp1_;
#line 312 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->password_label;
#line 312 "../src/PolkitDialog.vala"
		gtk_label_set_label (_tmp1_, request);
#line 1412 "PolkitDialog.c"
	}
}

static void
ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                           const gchar* text)
{
	GtkEntry* _tmp0_;
	GtkLabel* _tmp1_;
	GtkRevealer* _tmp2_;
#line 316 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 317 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 317 "../src/PolkitDialog.vala"
	g_object_set (_tmp0_, "secondary-icon-name", "dialog-error-symbolic", NULL);
#line 318 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_feedback;
#line 318 "../src/PolkitDialog.vala"
	gtk_label_set_label (_tmp1_, text);
#line 319 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 319 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, TRUE);
#line 320 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_shake (self);
#line 1441 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 324 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 326 "../src/PolkitDialog.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 326 "../src/PolkitDialog.vala"
	x = _tmp0_;
#line 326 "../src/PolkitDialog.vala"
	y = _tmp1_;
#line 1459 "PolkitDialog.c"
	{
		gint n = 0;
#line 328 "../src/PolkitDialog.vala"
		n = 0;
#line 1464 "PolkitDialog.c"
		{
			gboolean _tmp2_ = FALSE;
#line 328 "../src/PolkitDialog.vala"
			_tmp2_ = TRUE;
#line 328 "../src/PolkitDialog.vala"
			while (TRUE) {
#line 1471 "PolkitDialog.c"
				gint diff = 0;
#line 328 "../src/PolkitDialog.vala"
				if (!_tmp2_) {
#line 1475 "PolkitDialog.c"
					gint _tmp3_;
#line 328 "../src/PolkitDialog.vala"
					_tmp3_ = n;
#line 328 "../src/PolkitDialog.vala"
					n = _tmp3_ + 1;
#line 1481 "PolkitDialog.c"
				}
#line 328 "../src/PolkitDialog.vala"
				_tmp2_ = FALSE;
#line 328 "../src/PolkitDialog.vala"
				if (!(n < 10)) {
#line 328 "../src/PolkitDialog.vala"
					break;
#line 1489 "PolkitDialog.c"
				}
#line 329 "../src/PolkitDialog.vala"
				diff = 15;
#line 330 "../src/PolkitDialog.vala"
				if ((n % 2) == 0) {
#line 331 "../src/PolkitDialog.vala"
					diff = -15;
#line 1497 "PolkitDialog.c"
				}
#line 334 "../src/PolkitDialog.vala"
				gtk_window_move ((GtkWindow*) self, x + diff, y);
#line 336 "../src/PolkitDialog.vala"
				while (TRUE) {
#line 336 "../src/PolkitDialog.vala"
					if (!gtk_events_pending ()) {
#line 336 "../src/PolkitDialog.vala"
						break;
#line 1507 "PolkitDialog.c"
					}
#line 337 "../src/PolkitDialog.vala"
					gtk_main_iteration ();
#line 1511 "PolkitDialog.c"
				}
#line 340 "../src/PolkitDialog.vala"
				g_usleep ((gulong) 10000);
#line 1515 "PolkitDialog.c"
			}
		}
	}
#line 343 "../src/PolkitDialog.vala"
	gtk_window_move ((GtkWindow*) self, x, y);
#line 1521 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                          const gchar* text)
{
#line 346 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 346 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 347 "../src/PolkitDialog.vala"
	g_info ("PolkitDialog.vala:347: %s", text);
#line 1534 "PolkitDialog.c"
}

static gboolean
ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                         GdkEventKey* key)
{
	gboolean result = FALSE;
#line 350 "../src/PolkitDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 350 "../src/PolkitDialog.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 351 "../src/PolkitDialog.vala"
	switch (key->keyval) {
#line 351 "../src/PolkitDialog.vala"
		case GDK_KEY_KP_Enter:
#line 351 "../src/PolkitDialog.vala"
		case GDK_KEY_Return:
#line 1552 "PolkitDialog.c"
		{
#line 354 "../src/PolkitDialog.vala"
			ag_widgets_polkit_dialog_authenticate (self);
#line 355 "../src/PolkitDialog.vala"
			result = GDK_EVENT_STOP;
#line 355 "../src/PolkitDialog.vala"
			return result;
#line 1560 "PolkitDialog.c"
		}
		default:
#line 351 "../src/PolkitDialog.vala"
		break;
#line 1565 "PolkitDialog.c"
	}
#line 358 "../src/PolkitDialog.vala"
	result = GDK_EVENT_PROPAGATE;
#line 358 "../src/PolkitDialog.vala"
	return result;
#line 1571 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_class_init (AgWidgetsPolkitDialogClass * klass,
                                     gpointer klass_data)
{
#line 27 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/PolkitDialog.vala"
	g_type_class_adjust_private_offset (klass, &AgWidgetsPolkitDialog_private_offset);
#line 27 "../src/PolkitDialog.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) ag_widgets_polkit_dialog_real_show;
#line 27 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = ag_widgets_polkit_dialog_finalize;
#line 27 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL] = g_signal_new ("done", AG_WIDGETS_TYPE_POLKIT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1588 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_instance_init (AgWidgetsPolkitDialog * self,
                                        gpointer klass)
{
#line 27 "../src/PolkitDialog.vala"
	self->priv = ag_widgets_polkit_dialog_get_instance_private (self);
#line 29 "../src/PolkitDialog.vala"
	self->was_canceled = FALSE;
#line 31 "../src/PolkitDialog.vala"
	self->priv->pk_session = NULL;
#line 32 "../src/PolkitDialog.vala"
	self->priv->pk_identity = NULL;
#line 42 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 1605 "PolkitDialog.c"
}

static void
ag_widgets_polkit_dialog_finalize (GObject * obj)
{
	AgWidgetsPolkitDialog * self;
#line 27 "../src/PolkitDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog);
#line 31 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 32 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 41 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 44 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 45 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_label);
#line 46 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 47 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 48 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 27 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (ag_widgets_polkit_dialog_parent_class)->finalize (obj);
#line 1632 "PolkitDialog.c"
}

GType
ag_widgets_polkit_dialog_get_type (void)
{
	static volatile gsize ag_widgets_polkit_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&ag_widgets_polkit_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AgWidgetsPolkitDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_widgets_polkit_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgWidgetsPolkitDialog), 0, (GInstanceInitFunc) ag_widgets_polkit_dialog_instance_init, NULL };
		GType ag_widgets_polkit_dialog_type_id;
		ag_widgets_polkit_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "AgWidgetsPolkitDialog", &g_define_type_info, 0);
		AgWidgetsPolkitDialog_private_offset = g_type_add_instance_private (ag_widgets_polkit_dialog_type_id, sizeof (AgWidgetsPolkitDialogPrivate));
		g_once_init_leave (&ag_widgets_polkit_dialog_type_id__volatile, ag_widgets_polkit_dialog_type_id);
	}
	return ag_widgets_polkit_dialog_type_id__volatile;
}

