/* Utils.c generated by valac 0.45.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>   
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define AG_TYPE_SESSION_CLIENT (ag_session_client_get_type ())
#define AG_SESSION_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_TYPE_SESSION_CLIENT, AgSessionClient))
#define AG_IS_SESSION_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_TYPE_SESSION_CLIENT))
#define AG_SESSION_CLIENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), AG_TYPE_SESSION_CLIENT, AgSessionClientIface))

typedef struct _AgSessionClient AgSessionClient;
typedef struct _AgSessionClientIface AgSessionClientIface;

#define AG_TYPE_SESSION_CLIENT_PROXY (ag_session_client_proxy_get_type ())

#define AG_TYPE_SESSION_MANAGER (ag_session_manager_get_type ())
#define AG_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_TYPE_SESSION_MANAGER, AgSessionManager))
#define AG_IS_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_TYPE_SESSION_MANAGER))
#define AG_SESSION_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), AG_TYPE_SESSION_MANAGER, AgSessionManagerIface))

typedef struct _AgSessionManager AgSessionManager;
typedef struct _AgSessionManagerIface AgSessionManagerIface;

#define AG_TYPE_SESSION_MANAGER_PROXY (ag_session_manager_proxy_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AgUtilsRegisterWithSessionData AgUtilsRegisterWithSessionData;

struct _AgSessionClientIface {
	GTypeInterface parent_iface;
	void (*end_session_response) (AgSessionClient* self, gboolean is_ok, const gchar* reason, GError** error);
};

struct _AgSessionManagerIface {
	GTypeInterface parent_iface;
	void (*register_client) (AgSessionManager* self, const gchar* app_id, const gchar* client_start_id, GAsyncReadyCallback _callback_, gpointer _user_data_);
	char* (*register_client_finish) (AgSessionManager* self, GAsyncResult* _res_, GError** error);
};

struct _AgUtilsRegisterWithSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* app_id;
	AgSessionClient* result;
	AgSessionClient* sclient;
	char* path;
	gchar* start_id;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	AgSessionManager* session;
	AgSessionManager* _tmp4_;
	char* _tmp5_;
	AgSessionManager* _tmp6_;
	const gchar* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	GError* e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	AgSessionClient* _tmp12_;
	const char* _tmp13_;
	AgSessionClient* _tmp14_;
	AgSessionClient* _tmp15_;
	GError* _vala1_e;
	GError* _tmp16_;
	const gchar* _tmp17_;
	GError* _inner_error0_;
};

#define AG_UTILS_GNOME_SESSION_MANAGER_IFACE "org.gnome.SessionManager"
#define AG_UTILS_GNOME_SESSION_MANAGER_PATH "/org/gnome/SessionManager"
static void ag_utils_register_with_session_data_free (gpointer _data);
GType ag_session_client_proxy_get_type (void) G_GNUC_CONST;
guint ag_session_client_register_object (void* object,
                                         GDBusConnection* connection,
                                         const gchar* path,
                                         GError** error);
GType ag_session_client_get_type (void) G_GNUC_CONST;
void ag_utils_register_with_session (const gchar* app_id,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
AgSessionClient* ag_utils_register_with_session_finish (GAsyncResult* _res_);
static gboolean ag_utils_register_with_session_co (AgUtilsRegisterWithSessionData* _data_);
GType ag_session_manager_proxy_get_type (void) G_GNUC_CONST;
guint ag_session_manager_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
GType ag_session_manager_get_type (void) G_GNUC_CONST;
static void ag_utils_register_with_session_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
void ag_session_manager_register_client (AgSessionManager* self,
                                         const gchar* app_id,
                                         const gchar* client_start_id,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
char* ag_session_manager_register_client_finish (AgSessionManager* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);

static void
ag_utils_register_with_session_data_free (gpointer _data)
{
	AgUtilsRegisterWithSessionData* _data_;
	_data_ = _data;
	_g_free0 (_data_->app_id);
	_g_object_unref0 (_data_->result);
	g_slice_free (AgUtilsRegisterWithSessionData, _data_);
}

void
ag_utils_register_with_session (const gchar* app_id,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	AgUtilsRegisterWithSessionData* _data_;
	gchar* _tmp0_;
	_data_ = g_slice_new0 (AgUtilsRegisterWithSessionData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, ag_utils_register_with_session_data_free);
	_tmp0_ = g_strdup (app_id);
	_g_free0 (_data_->app_id);
	_data_->app_id = _tmp0_;
	ag_utils_register_with_session_co (_data_);
}

AgSessionClient*
ag_utils_register_with_session_finish (GAsyncResult* _res_)
{
	AgSessionClient* result;
	AgUtilsRegisterWithSessionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
ag_utils_register_with_session_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	AgUtilsRegisterWithSessionData* _data_;
#line 42 "../src/Utils.vala"
	_data_ = _user_data_;
#line 42 "../src/Utils.vala"
	_data_->_source_object_ = source_object;
#line 42 "../src/Utils.vala"
	_data_->_res_ = _res_;
#line 42 "../src/Utils.vala"
	ag_utils_register_with_session_co (_data_);
#line 188 "Utils.c"
}

static gboolean
ag_utils_register_with_session_co (AgUtilsRegisterWithSessionData* _data_)
{
#line 30 "../src/Utils.vala"
	switch (_data_->_state_) {
#line 30 "../src/Utils.vala"
		case 0:
#line 198 "Utils.c"
		goto _state_0;
#line 30 "../src/Utils.vala"
		case 1:
#line 202 "Utils.c"
		goto _state_1;
#line 30 "../src/Utils.vala"
		case 2:
#line 206 "Utils.c"
		goto _state_2;
#line 30 "../src/Utils.vala"
		case 3:
#line 210 "Utils.c"
		goto _state_3;
		default:
#line 30 "../src/Utils.vala"
		g_assert_not_reached ();
#line 215 "Utils.c"
	}
	_state_0:
#line 31 "../src/Utils.vala"
	_data_->sclient = NULL;
#line 32 "../src/Utils.vala"
	_data_->path = NULL;
#line 34 "../src/Utils.vala"
	_data_->_tmp0_ = g_getenv ("DESKTOP_AUTOSTART_ID");
#line 34 "../src/Utils.vala"
	_data_->_tmp1_ = g_strdup (_data_->_tmp0_);
#line 34 "../src/Utils.vala"
	_data_->start_id = _data_->_tmp1_;
#line 35 "../src/Utils.vala"
	_data_->_tmp2_ = _data_->start_id;
#line 35 "../src/Utils.vala"
	if (_data_->_tmp2_ != NULL) {
#line 36 "../src/Utils.vala"
		g_unsetenv ("DESKTOP_AUTOSTART_ID");
#line 234 "Utils.c"
	} else {
#line 38 "../src/Utils.vala"
		_data_->_tmp3_ = g_strdup ("");
#line 38 "../src/Utils.vala"
		_g_free0 (_data_->start_id);
#line 38 "../src/Utils.vala"
		_data_->start_id = _data_->_tmp3_;
#line 242 "Utils.c"
	}
	{
#line 42 "../src/Utils.vala"
		_data_->_state_ = 1;
#line 42 "../src/Utils.vala"
		g_async_initable_new_async (AG_TYPE_SESSION_MANAGER_PROXY, 0, NULL, ag_utils_register_with_session_ready, _data_, "g-flags", 0, "g-name", AG_UTILS_GNOME_SESSION_MANAGER_IFACE, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", AG_UTILS_GNOME_SESSION_MANAGER_PATH, "g-interface-name", "org.gnome.SessionManager", "g-interface-info", g_type_get_qdata (AG_TYPE_SESSION_MANAGER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 42 "../src/Utils.vala"
		return FALSE;
#line 251 "Utils.c"
		_state_1:
#line 42 "../src/Utils.vala"
		_data_->_tmp4_ = (AgSessionManager*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 42 "../src/Utils.vala"
		_data_->session = (AgSessionManager*) _data_->_tmp4_;
#line 42 "../src/Utils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 259 "Utils.c"
			goto __catch3_g_error;
		}
#line 43 "../src/Utils.vala"
		_data_->_tmp6_ = _data_->session;
#line 43 "../src/Utils.vala"
		_data_->_tmp7_ = _data_->start_id;
#line 43 "../src/Utils.vala"
		_data_->_state_ = 2;
#line 43 "../src/Utils.vala"
		ag_session_manager_register_client (_data_->_tmp6_, _data_->app_id, _data_->_tmp7_, ag_utils_register_with_session_ready, _data_);
#line 43 "../src/Utils.vala"
		return FALSE;
#line 272 "Utils.c"
		_state_2:
#line 43 "../src/Utils.vala"
		_data_->_tmp8_ = ag_session_manager_register_client_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 43 "../src/Utils.vala"
		_data_->_tmp5_ = _data_->_tmp8_;
#line 43 "../src/Utils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 43 "../src/Utils.vala"
			_g_object_unref0 (_data_->session);
#line 282 "Utils.c"
			goto __catch3_g_error;
		}
#line 43 "../src/Utils.vala"
		_data_->_tmp9_ = _data_->_tmp5_;
#line 43 "../src/Utils.vala"
		_data_->_tmp5_ = NULL;
#line 43 "../src/Utils.vala"
		_g_free0 (_data_->path);
#line 43 "../src/Utils.vala"
		_data_->path = _data_->_tmp9_;
#line 41 "../src/Utils.vala"
		_g_free0 (_data_->_tmp5_);
#line 41 "../src/Utils.vala"
		_g_object_unref0 (_data_->session);
#line 297 "Utils.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
#line 41 "../src/Utils.vala"
		_data_->e = _data_->_inner_error0_;
#line 41 "../src/Utils.vala"
		_data_->_inner_error0_ = NULL;
#line 45 "../src/Utils.vala"
		_data_->_tmp10_ = _data_->e;
#line 45 "../src/Utils.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 45 "../src/Utils.vala"
		g_warning ("Utils.vala:45: Error registering client: %s", _data_->_tmp11_);
#line 46 "../src/Utils.vala"
		_data_->result = NULL;
#line 46 "../src/Utils.vala"
		_g_error_free0 (_data_->e);
#line 46 "../src/Utils.vala"
		_g_free0 (_data_->start_id);
#line 46 "../src/Utils.vala"
		_g_free0 (_data_->path);
#line 46 "../src/Utils.vala"
		_g_object_unref0 (_data_->sclient);
#line 46 "../src/Utils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 46 "../src/Utils.vala"
		if (_data_->_state_ != 0) {
#line 46 "../src/Utils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 46 "../src/Utils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 330 "Utils.c"
			}
		}
#line 46 "../src/Utils.vala"
		g_object_unref (_data_->_async_result);
#line 46 "../src/Utils.vala"
		return FALSE;
#line 337 "Utils.c"
	}
	__finally3:
#line 41 "../src/Utils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 41 "../src/Utils.vala"
		_g_free0 (_data_->start_id);
#line 41 "../src/Utils.vala"
		_g_free0 (_data_->path);
#line 41 "../src/Utils.vala"
		_g_object_unref0 (_data_->sclient);
#line 41 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 41 "../src/Utils.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 41 "../src/Utils.vala"
		g_object_unref (_data_->_async_result);
#line 41 "../src/Utils.vala"
		return FALSE;
#line 356 "Utils.c"
	}
	{
#line 50 "../src/Utils.vala"
		_data_->_tmp13_ = _data_->path;
#line 50 "../src/Utils.vala"
		_data_->_state_ = 3;
#line 50 "../src/Utils.vala"
		g_async_initable_new_async (AG_TYPE_SESSION_CLIENT_PROXY, 0, NULL, ag_utils_register_with_session_ready, _data_, "g-flags", 0, "g-name", AG_UTILS_GNOME_SESSION_MANAGER_IFACE, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", (const gchar*) _data_->_tmp13_, "g-interface-name", "org.gnome.SessionManager.ClientPrivate", "g-interface-info", g_type_get_qdata (AG_TYPE_SESSION_CLIENT, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 50 "../src/Utils.vala"
		return FALSE;
#line 367 "Utils.c"
		_state_3:
#line 50 "../src/Utils.vala"
		_data_->_tmp14_ = (AgSessionClient*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 50 "../src/Utils.vala"
		_data_->_tmp12_ = (AgSessionClient*) _data_->_tmp14_;
#line 50 "../src/Utils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 375 "Utils.c"
			goto __catch4_g_error;
		}
#line 50 "../src/Utils.vala"
		_data_->_tmp15_ = _data_->_tmp12_;
#line 50 "../src/Utils.vala"
		_data_->_tmp12_ = NULL;
#line 50 "../src/Utils.vala"
		_g_object_unref0 (_data_->sclient);
#line 50 "../src/Utils.vala"
		_data_->sclient = _data_->_tmp15_;
#line 49 "../src/Utils.vala"
		_g_object_unref0 (_data_->_tmp12_);
#line 388 "Utils.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
#line 49 "../src/Utils.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 49 "../src/Utils.vala"
		_data_->_inner_error0_ = NULL;
#line 52 "../src/Utils.vala"
		_data_->_tmp16_ = _data_->_vala1_e;
#line 52 "../src/Utils.vala"
		_data_->_tmp17_ = _data_->_tmp16_->message;
#line 52 "../src/Utils.vala"
		g_warning ("Utils.vala:52: Unable to get Private Client proxy: %s", _data_->_tmp17_);
#line 53 "../src/Utils.vala"
		_data_->result = NULL;
#line 53 "../src/Utils.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 53 "../src/Utils.vala"
		_g_free0 (_data_->start_id);
#line 53 "../src/Utils.vala"
		_g_free0 (_data_->path);
#line 53 "../src/Utils.vala"
		_g_object_unref0 (_data_->sclient);
#line 53 "../src/Utils.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 53 "../src/Utils.vala"
		if (_data_->_state_ != 0) {
#line 53 "../src/Utils.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 53 "../src/Utils.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 421 "Utils.c"
			}
		}
#line 53 "../src/Utils.vala"
		g_object_unref (_data_->_async_result);
#line 53 "../src/Utils.vala"
		return FALSE;
#line 428 "Utils.c"
	}
	__finally4:
#line 49 "../src/Utils.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 49 "../src/Utils.vala"
		_g_free0 (_data_->start_id);
#line 49 "../src/Utils.vala"
		_g_free0 (_data_->path);
#line 49 "../src/Utils.vala"
		_g_object_unref0 (_data_->sclient);
#line 49 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 49 "../src/Utils.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 49 "../src/Utils.vala"
		g_object_unref (_data_->_async_result);
#line 49 "../src/Utils.vala"
		return FALSE;
#line 447 "Utils.c"
	}
#line 56 "../src/Utils.vala"
	_data_->result = _data_->sclient;
#line 56 "../src/Utils.vala"
	_g_free0 (_data_->start_id);
#line 56 "../src/Utils.vala"
	_g_free0 (_data_->path);
#line 56 "../src/Utils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 56 "../src/Utils.vala"
	if (_data_->_state_ != 0) {
#line 56 "../src/Utils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 56 "../src/Utils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 463 "Utils.c"
		}
	}
#line 56 "../src/Utils.vala"
	g_object_unref (_data_->_async_result);
#line 56 "../src/Utils.vala"
	return FALSE;
#line 470 "Utils.c"
}

